#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define	MAXBUFF		0x2000

void	readfont(FILE *fontfp, int buff[MAXBUFF], long int offset, int stchr, int edchr);

int main(int argc, char **argv)
{
	FILE	*infp;
	FILE	*outfp;
	FILE	*fontfp;

	int		buff[MAXBUFF];

	int		width,height;
	int		wb;
	int		x,y;
	int		m,n,i,j,k;
	int		col,colct;
	int		a0,a1,a2,a3,c;
	int		sft;
	int		filelen;
	int		f0,f1,f2,f3,f4,f5,f6,f7;

	if (argc != 4) {
		fprintf(stderr, "Usage: convletter fontfile infile outfile\n");
		exit(1);
	}

/* open files */

	if ((fontfp = fopen(argv[1], "rb")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	if ((infp = fopen(argv[2], "rb")) == NULL) {
		perror(argv[2]);
		exit(1);
	}

	if ((outfp = fopen(argv[3], "wb")) == NULL) {
		perror(argv[3]);
		exit(1);
	}

	i = 0;
	while ( (c = fgetc(infp)) != EOF) {
		buff[i] = c;
		i ++;
	}
	filelen = i;

	for (i = 0;i < 0x1ff;i ++) {
		for (y = 0;y < 8;y ++) {
			buff[i*16+y] =
						( ( (buff[i*16+y*2+0] & 0x80) != 0x00) ? 0x80 : 0x00) + 
						( ( (buff[i*16+y*2+0] & 0x20) != 0x00) ? 0x40 : 0x00) + 
						( ( (buff[i*16+y*2+0] & 0x08) != 0x00) ? 0x20 : 0x00) + 
						( ( (buff[i*16+y*2+0] & 0x02) != 0x00) ? 0x10 : 0x00) + 
						( ( (buff[i*16+y*2+1] & 0x80) != 0x00) ? 0x08 : 0x00) + 
						( ( (buff[i*16+y*2+1] & 0x20) != 0x00) ? 0x04 : 0x00) + 
						( ( (buff[i*16+y*2+1] & 0x08) != 0x00) ? 0x02 : 0x00) + 
						( ( (buff[i*16+y*2+1] & 0x02) != 0x00) ? 0x01 : 0x00);
		}

		for (y = 0;y < 8;y ++) {
			buff[i*16+y+8] = 0x00;
		}
	}

	readfont(fontfp, buff, 0x00c8, 0x21, 0x21); /* ! */
	readfont(fontfp, buff, 0x01c0, 0x22, 0x22); /* " */
	readfont(fontfp, buff, 0x0318, 0x23, 0x23); /* # */
	readfont(fontfp, buff, 0x02f8, 0x24, 0x24); /* $ */
	readfont(fontfp, buff, 0x0310, 0x25, 0x25); /* % */
	readfont(fontfp, buff, 0x0320, 0x26, 0x26); /* & */
	readfont(fontfp, buff, 0x01b0, 0x27, 0x27); /* ' */
	readfont(fontfp, buff, 0x01c8, 0x28, 0x29); /* () */
	readfont(fontfp, buff, 0x0328, 0x2a, 0x2a); /* * */
	readfont(fontfp, buff, 0x0258, 0x2b, 0x2b); /* + */
	readfont(fontfp, buff, 0x0098, 0x2c, 0x2c); /* , */
	readfont(fontfp, buff, 0x0260, 0x2d, 0x2d); /* - */
	readfont(fontfp, buff, 0x00a0, 0x2e, 0x2e); /* . */
	readfont(fontfp, buff, 0x0170, 0x2f, 0x2f); /* / */
	readfont(fontfp, buff, 0x06d8, 0x30, 0x39); /* 0`9 */
	readfont(fontfp, buff, 0x00b0, 0x3a, 0x3b); /* :; */
	readfont(fontfp, buff, 0x0290, 0x3c, 0x3c); /* < */
	readfont(fontfp, buff, 0x0280, 0x3d, 0x3d); /* = */
	readfont(fontfp, buff, 0x0298, 0x3e, 0x3e); /* > */
	readfont(fontfp, buff, 0x00c0, 0x3f, 0x3f); /* ? */
	readfont(fontfp, buff, 0x0330, 0x40, 0x40); /* @ */
	readfont(fontfp, buff, 0x0760, 0x41, 0x5a); /* A`Z */
	readfont(fontfp, buff, 0x0950, 0x81, 0xd3); /* ` */
	readfont(fontfp, buff, 0x0c40, 0xd4, 0x129); /* @` 0x0950- */

	i = 0x77;		/* of */
	buff[i*16+0] = 0x02;
	buff[i*16+1] = 0x44;
	buff[i*16+2] = 0xa4;
	buff[i*16+3] = 0xae;
	buff[i*16+4] = 0x44;
	buff[i*16+5] = 0x04;
	buff[i*16+6] = 0x08;
	buff[i*16+7] = 0x00;
	for (y = 0;y < 8;y ++) {
		buff[i*16+y+8] = 0x00;
	}

	i = 0x78;		/* potion */
	buff[i*16+0] = 0xfe;
	buff[i*16+1] = 0x38;
	buff[i*16+2] = 0x54;
	buff[i*16+3] = 0xaa;
	buff[i*16+4] = 0xd6;
	buff[i*16+5] = 0xaa;
	buff[i*16+6] = 0x7c;
	buff[i*16+7] = 0x00;
	for (y = 0;y < 8;y ++) {
		buff[i*16+y+8] = 0x00;
	}

	i = 0x79;		/* scroll */
	buff[i*16+0] = 0x78;
	buff[i*16+1] = 0xc4;
	buff[i*16+2] = 0xd4;
	buff[i*16+3] = 0x44;
	buff[i*16+4] = 0x54;
	buff[i*16+5] = 0x46;
	buff[i*16+6] = 0x3e;
	buff[i*16+7] = 0x00;
	for (y = 0;y < 8;y ++) {
		buff[i*16+y+8] = 0x00;
	}

	for (i = 0;i < filelen;i ++) {
		if ( (i%16) < 8) {
			fputc(buff[i],outfp);
		}
	}

	fclose(infp);
	fclose(outfp);

	return(0);
}

void	readfont(FILE *fontfp, int buff[MAXBUFF], long int offset, int stchr, int edchr)
{
	int		i,y;
	int		f0,f1,f2,f3,f4,f5,f6,f7;
	int		sft;

	fseek(fontfp,offset,SEEK_SET);
	for (i = stchr;i <= edchr;i ++) {
		f0 = fgetc(fontfp);
		f1 = fgetc(fontfp);
		f2 = fgetc(fontfp);
		f3 = fgetc(fontfp);
		f4 = fgetc(fontfp);
		f5 = fgetc(fontfp);
		f6 = fgetc(fontfp);
		f7 = fgetc(fontfp);
		sft = 0x01;
		for (y = 0;y < 8;y ++) {
			buff[i*16+y] =
				( ((f0 & sft) != 0x00) ? 0x80 : 0x00) +
				( ((f1 & sft) != 0x00) ? 0x40 : 0x00) +
				( ((f2 & sft) != 0x00) ? 0x20 : 0x00) +
				( ((f3 & sft) != 0x00) ? 0x10 : 0x00) +
				( ((f4 & sft) != 0x00) ? 0x08 : 0x00) +
				( ((f5 & sft) != 0x00) ? 0x04 : 0x00) +
				( ((f6 & sft) != 0x00) ? 0x02 : 0x00) +
				( ((f7 & sft) != 0x00) ? 0x01 : 0x00);
			sft *= 2;
		}
		for (y = 0;y < 8;y ++) {
			buff[i*16+y+8] = 0x00;
		}
	}

	return;

}

